<template>
  <div class="products-container">
    <carousel
      :perPage="4"
      :navigationEnabled="true"
      :pagination-enabled="false"
      :center-mode="true"
      :scroll-per-page="false"
      :navigation-click-target-size="14"
      style="width: 1140px !important;">
      <slide
        v-for="(product, index) in products"
        >
        <div class="single-product"
             @mouseenter="hover(index, true)"
             @mouseleave="hover(index, false)"
             :key="index">
          <p class="price" v-if="!product.discount">{{ product.price }} zł</p>
          <div class="price-with-discount" v-else>
            <div class="discount-percentages">
              {{ product.discount }}%
            </div>
            <span class="price">{{ product.price }} zł</span>
            <span class="price-crossed">{{ priceCrossed(product.price, product.discount) }} zł</span>
          </div>
          <img :src="setSrc(product.image)" :alt="product.price">
          <p class="product-name">{{ product['prod-title'] }}</p>
          <div class="buy-button"
               @click="enterProductPage(index)">
            <span>KUP TERAZ</span>
          </div>
        </div>
      </slide>
    </carousel>
  </div>

</template>

<script>
  export default {
    name: 'Product',
    data() {
      return {
        products: []
      }
    },
    beforeCreate() {
      this.$http.get('https://upland-digital-task-vuejs.firebaseio.com/products.json').then(response => {
        this.products = response.body;
      });
    },
    methods: {
      setSrc(product) {
        return require('../' + product)
      },
      priceCrossed(price, discount) {
        let priceInt = parseInt(price);
        let discountInt = parseInt(discount);
        return priceInt + priceInt * discountInt / 100;
      },
      enterProductPage(index) {
        window.location.href = this.products[index].link;
      },
      hover(index, boolean) {
        if (boolean) {
          document.querySelectorAll('.buy-button')[index].style.height = 53 + 'px';
          document.querySelectorAll('.buy-button span')[index].style.height = 15.2 + 'px';
        } else {
          document.querySelectorAll('.buy-button')[index].style.height = 0;
          document.querySelectorAll('.buy-button span')[index].style.height = 0;
        }
      }
    }
  }
</script>

<style scoped>
  img {
    height: 200px;
    width: 200px;
    margin: 0 auto 5px;
  }

  .products-container {
    display: flex;
    flex-direction: row;
    justify-content: center;
  }

  .single-product {
    display: flex;
    flex-direction: column;
    justify-content: space-around;
    border-style: solid;
    border-width: 1px;
    border-color: rgb(226, 226, 226);
    border-radius: 5px;
    background-color: rgb(255, 255, 255);
    box-shadow: 0 3px 10px 0 rgba(0, 0, 0, 0.06);
    width: 253px;
    height: 333px;
    margin: 0 15px;
  }

  .price {
    font-size: 16px;
    color: rgb(246, 0, 14);
    font-weight: bold;
    line-height: 1.2;
    text-align: left;
    margin: 5px 5px 0 15px;
  }

  span.price {
    margin: 5px 6px 0 8px !important;
  }

  p.price {
    height: 27px;
    margin-top: 8px !important;
  }

  .price-crossed {
    font-size: 12px;
    text-decoration: line-through;
    font-weight: bold;
  }

  .price-with-discount {
    display: flex;
    align-items: baseline;
  }

  .discount-percentages {
    width: 35px;
    height: 35px;
    color: #fff;
    display: flex;
    align-items: center;
    text-align: center;
    justify-content: center;
    border-radius: 50%;
    background-color: rgb(246, 0, 14);
    font-size: 12px;
    margin-left: 12px;
  }

  .product-name {
    font-size: 14px;
    font-family: 'Ubuntu', serif;
    color: rgb(0, 0, 0);
    font-weight: bold;
    line-height: 1.2;
    text-align: center;
    margin: 0 10px;
    height: 34px;
    align-items: center;
    justify-content: center;
    display: flex;
  }

  .buy-button {
    background-color: rgb(226, 226, 226);
    position: absolute;
    width: 254px;
    height: 0;
    display: flex;
    justify-content: center;
    align-items: center;
    bottom: 0;
    border-bottom-left-radius: 5px;
    border-bottom-right-radius: 5px;
    cursor: pointer;
    transition: all .2s ease-in-out;
    opacity: 1;
  }

  .buy-button span {
    font-size: 13px;
    color: rgb(0, 0, 0);
    font-weight: bold;
    line-height: 1.2;
    height: 0;
  }
</style>
